=== tests/Makefile ===
include common.mak

TESTS := genhtml/ lcov/ gendiffcov/ py2lcov

clean:
	rm -rf *.info *.counts test.log src/ ./cover_db
