=== tests/genhtml/Makefile ===
include ../common.mak

TESTS := full.sh part1.sh part2.sh target.sh zero.sh demangle.sh

clean:
	rm -rf *.log out_* *.tmp
