=== tests/lcov/Makefile ===
include ../common.mak

TESTS := add/ diff/ misc/ summary/ extract/ demangle/ exception/ gcov-tool/
