=== tests/py2lcov/Makefile ===
include ../common.mak

TESTS : py2lcov.sh

clean:
	$(shell ./py2lcov.sh --clean)
