=== tests/gendiffcov/filter/Makefile ===
include ../../common.mak

TESTS := filter.pl

clean:
	rm -f *.orig *.filtered
