=== tests/gendiffcov/insensitive/Makefile ===
include ../../common.mak

TESTS := insensitive.sh

clean:
	$(shell ./insensitive.sh --clean)
