=== tests/lcov/exception/Makefile ===
include ../../common.mak

TESTS := exception.sh

clean:
	$(shell ./exception.sh --clean)
