=== debian/changelog ===
lcov (2.0-4ubuntu2) noble; urgency=medium

  * Add missing runtime dependency on libtimedate-perl (LP: #2058956)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 25 Mar 2024 16:44:44 +0000

lcov (2.0-4ubuntu1) noble; urgency=medium

  * Re-enable tests by disabling multiple threads while building. Tests are
  * failing with multiple threads. (LP: #2052836)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 09 Feb 2024 20:28:32 +0000

lcov (2.0-4) unstable; urgency=medium

  * Missing runtime dependency on libdatetime-perl and libcapture-tiny-perl.
    Thanks  Diego Escalante Urrelo. Closes: #1053252
  * Mark lcov as Multi-arch: Foreign. Closes: #1040402

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Jan 2024 12:23:45 +0000

lcov (2.0-3) unstable; urgency=medium

  * Bypass tests: currently they hang build 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Sep 2023 15:56:37 +0100

lcov (2.0-2) unstable; urgency=medium

  * Ship lcovutil.pm in /usr/share/perl5. Closes: #1043009
  * Close bug fixed in lcov 1.16. Closes: #1035394
  * Patches obsolete/removed:
    - gcc8.patch
    - gcc-9-support.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Sep 2023 13:17:44 +0100

lcov (2.0-1) unstable; urgency=medium

  * New upstream release
  * Patches now obsolete/merged:
    - handle-equals-signs.patch
    - fix-undef-behaviour.patch
    - reproducibility2.patch
    - 0001-bin-updateversion.pl-avoid-setting-timestamp-bui.patch
  * Fix by Vagrant Cascadian of embedded tz in timestamps breaking
    reproucibility. Closes: #10354394
  * Standards-Version: 4.6.2
  * Build-Dep on libdatetime-perl, libcapture-tiny-perl

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Aug 2023 16:19:48 +0100
