=== debian/control ===
Source: lcov
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
  libjson-perl, 
  libperlio-gzip-perl, 
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Homepage: https://github.com/linux-test-project/lcov.git
Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
Standards-Version: 4.6.2

Package: lcov
Architecture: all
Depends:
  ${misc:Depends},
  ${perl:Depends},
  gcc,
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl,
  libjson-perl,
  libperlio-gzip-perl
Recommends: libgd-gd2-perl
Multi-Arch: foreign
Section: devel
Priority: optional
Description: Summarise Code coverage information from GCOV
 LCOV is an extension of GCOV, a GNU tool which provides information about
 what parts of a program are actually executed (i.e. "covered") while running
 a particular test case. The extension consists of a set of Perl scripts
 which build on the textual GCOV output to implement the following enhanced
 functionality:
 . 	                                                                                
  - HTML based output: coverage rates are additionally indicated using bar
    graphs and specific colors.
  - Support for large projects: overview pages allow quick browsing of
    coverage data by providing three levels of detail: directory view,
    file view and source code view.
