=== debian/rules ===
#!/usr/bin/make -f

# Debhelper rules

export DH_VERBOSE=1

LC_ALL=C
export LC_ALL

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	rm -rf  debian/lcov/usr/etc
