=== example/Makefile ===
--- 
+++ 
@@ -11,10 +11,26 @@
 CFLAGS  := -Wall -I. --coverage
 LDFLAGS  := --coverage
 
-LCOV    := ../bin/lcov
-GENHTML := ../bin/genhtml
-GENDESC := ../bin/gendesc
-GENPNG  := ../bin/genpng
+LCOV_FLAGS = --branch
+
+# path differs depending on whether we are in the install dir or not
+# run with "make LCOV_HOME=/path/to/my/release" if necessary
+
+ifeq ($(LCOV_HOME),)
+LCOV_HOME := $(shell if [ -d ../bin ] ; then echo `realpath ..` ; else echo `realpath ../../..` ; fi)
+endif
+
+EG_SRCDIR = $(shell if [ -d $(LCOV_HOME)/example ] ; then echo $(LCOV_HOME)/example ; else echo $(LCOV_HOME)/share/lcov/example ; fi)
+# override this variable to write the differential testcase data someplace
+#  else
+REPO = exampleRepo
+BINDIR = $(LCOV_HOME)/bin
+SCRIPTS = $(LCOV_HOME)/scripts
+LCOV    := $(BINDIR)/lcov $(LCOV_FLAGS)
+GENHTML := $(BINDIR)/genhtml $(LCOV_FLAGS)
+GENDESC := $(BINDIR)/gendesc
+GENPNG  := $(BINDIR)/genpng
+SCRIPTDIR = $(shell if [ -d ../scripts ] ; then echo $(SCRIPTS) ; else echo $(LCOV_HOME)/share/lcov/support-scripts ; fi)
 
 # Depending on the presence of the GD.pm perl module, we can use the
 # special option '--frames' for genhtml
@@ -34,12 +50,12 @@
 endif
 
 
-.PHONY: clean output test_noargs test_2_to_2000 test_overflow
+.PHONY: clean output test_noargs test_2_to_2000 test_overflow test_differential
 
 all: output
 
 example: example.o iterate.o gauss.o
-	$(CC) example.o iterate.o gauss.o -o example $(LDFLAGS)
+	$(CC) $^ -o $@ $(LDFLAGS)
 
 example.o: example.c iterate.h gauss.h
 	$(CC) $(CFLAGS) -c example.c -o example.o
@@ -50,7 +66,7 @@
 gauss.o: methods/gauss.c gauss.h
 	$(CC) $(CFLAGS) -c methods/gauss.c -o gauss.o
 
-output: example descriptions test_noargs test_2_to_2000 test_overflow
+output: example descriptions test_noargs test_2_to_2000 test_overflow test_differential
 	@echo
 	@echo '*'
 	@echo '* Generating HTML output'
@@ -65,11 +81,21 @@
 	@echo '* See '`pwd`/output/index.html
 	@echo '*'
 	@echo
+	@echo "Generate HTML with hierarchical report and additional navigation features"
+	@echo '*'
+	$(GENHTML) trace_noargs.info trace_args.info trace_overflow.info \
+		   --output-directory hierarchical \
+		   --title "Basic example - hierarchical" \
+		   --show-details --hierarchical --show-navigation \
+		   --description-file descriptions $(FRAMES) \
+		   --legend
+	@echo
+	@echo '* See '`pwd`/hierarchical/index.html
 
 descriptions: descriptions.txt
 	$(GENDESC) descriptions.txt -o descriptions
 
-all_tests: example test_noargs test_2_to_2000 test_overflow
+all_tests: example test_noargs test_2_to_2000 test_overflow differential
 
 test_noargs:
 	@echo
@@ -101,7 +127,88 @@
 	./example 0 100000 || true
 	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow" --no-external
 
+# This test pretends to write some code, run some tests, then modify
+#   code and rerun some tests.
+# The differential coverage report is categorizes the code based on
+#   what changed in the source code and what changed in the tests.
+# Note that we are suing perl module for callbacks here - but could use
+#   script or executable if desired.
+# Could use --verbose and --quiet flags to make the execution less noisy -
+#   but verbosity can help to debug configuration issues.
+# See the lcov README and man pages for more details.
+test_differential:
+	@echo
+	@echo '*'
+	@echo '* Test case 4: differential coverage example'
+	@echo '*'
+	@echo
+	@echo "Step 1: Initialize GIT repo with example source"
+	@$(RM) -rf $(REPO)
+	@git init $(REPO) ;
+	@(cd $(REPO) ; \
+	cp -f $(EG_SRCDIR)/*.h $(EG_SRCDIR)/example.c . ; \
+	mkdir methods ; cp -f $(EG_SRCDIR)/methods/{iterate,gauss}.c methods ; \
+	find . \( -name '*.h' -o -name '*.c' \) -exec git add {} \; ; \
+	git commit -m baseline ; git tag baseline )
+	@echo "Build example and run some tests"
+	(cd $(REPO) ; \
+	$(CC) -o example --coverage -I. example.c methods/gauss.c methods/iterate.c ; \
+	./example ; \
+	./example 2 1000 ; \
+	./example 2 100000 || true )
+
+	@echo "Step 2: Capture initial coverage"
+	(cd $(REPO) ; \
+	$(LCOV) --capture -o baseline.info -d . --version-script $(SCRIPTDIR)/gitversion.pm )
+
+	@echo "Step 3: Modify source code"
+	@(cd $(REPO) ; \
+	cp -f $(EG_SRCDIR)/example_mod.c example.c ; \
+	cp -f $(EG_SRCDIR)/methods/iterate_mod.c methods/iterate.c ; \
+	git add example.c methods/iterate.c ; git commit -m current ; \
+	git tag current )
+
+	@echo "Step 4: Rebuild and run tests (fewer tests this time)"
+	( cd $(REPO) ; \
+	find . -name '*.gc*' -delete ; \
+	$(CC) -o example --coverage -I. example.c methods/gauss.c methods/iterate.c ; \
+	./example )
+
+	@echo "Step 5: Capture new coverage (after source changes)"
+	(cd $(REPO) ; \
+	 $(LCOV) --capture -o current.info -d . --version-script $(SCRIPTDIR)/gitversion.pm )
+	@echo "Compute source diffs"
+	(cd $(REPO) ;                                       \
+	$(SCRIPTDIR)/gitdiff . `git rev-list -n 1 baseline` \
+	  `git rev-list -n 1 current` > udiff.txt )
+
+	@echo "Step 6: Generate differential coverage report"
+	(cd $(REPO) ;                                            \
+	$(GENHTML) -o differential --baseline-file baseline.info \
+	  --diff-file udiff.txt                                  \
+	  --title "Differential coverage example" --show-owners  \
+	  --annotate $(SCRIPTDIR)/gitblame.pm                    \
+	  --version-script $(SCRIPTDIR)/gitversion.pm            \
+	  -- current.info )
+
+	@echo "point your browser to `realpath $(REPO)`/differential/index.html"
+
+	@echo "Step 7: Generate subset report for code review:"
+	(cd $(REPO) ;                                            \
+	$(GENHTML) -o review --baseline-file baseline.info \
+	  --diff-file udiff.txt                                  \
+	  --title "Differential report for code review" --show-owners  \
+	  --annotate $(SCRIPTDIR)/gitblame.pm                    \
+	  --version-script $(SCRIPTDIR)/gitversion.pm            \
+	  --select-script $(SCRIPTDIR)/select.pm                 \
+	  --select-script --tla --select-script UNC,UIC,LBC      \
+	  -- current.info )
+
+	@echo "point your browser to `realpath $(REPO)`/review/index.html"
+
+
 clean:
 	$(call echocmd,"  CLEAN   lcov/example")
 	rm -rf *.o *.bb *.bbg *.da *.gcno *.gcda *.info output example \
-	descriptions
+	descriptions \
+	$(REPO) hierarchical
