=== debian/changelog ===
lcov (2.1~beta2-1) unstable; urgency=medium

  * New upstream release
  * Depend on python:Depends

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Apr 2024 16:22:38 +0100

lcov (2.1~beta-1) unstable; urgency=medium

  * New upstream release
  * Depend on libtimedate-perl, python. Closes: #1067687
  * Re-enable tests
  * Add B-D on libdevel-cover-perl

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Mar 2024 07:07:09 +0000

lcov (2.0-5) UNRELEASED; urgency=medium

  * Disable multiple threads while building. Tests are failing
    with multiple threads.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 23 Jan 2024 21:27:37 +0000
