=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
   libperlio-gzip-perl, 
   libcapture-tiny-perl,
   libdatetime-perl,
-  libtimedate-perl
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+  libtimedate-perl,
+  libdevel-cover-perl
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: https://github.com/linux-test-project/lcov.git
 Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
@@ -19,6 +19,7 @@
 Depends:
   ${misc:Depends},
   ${perl:Depends},
+  ${python3:Depends},
   gcc,
   libcapture-tiny-perl,
   libdatetime-perl,
