=== debian/rules ===
--- 
+++ 
@@ -13,3 +13,6 @@
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
 	rm -rf  debian/lcov/usr/etc
+
+# override_dh_auto_test:
+#	@echo Bypass tests - break build
