## lcov 2.1

=== debian/changelog ===
lcov (2.1-1) unstable; urgency=medium

  * New upstream release
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Drop unnecessary field in d/control
  * Drop .git extensions on URLs as per lintian
  * Add B-D for dh-sequence-python3, helper
  * Fix paths on shell,perl scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Sep 2024 17:56:04 +0100
