=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+  dh-sequence-python3,
   libjson-perl, 
   libperlio-gzip-perl, 
   libcapture-tiny-perl,
@@ -9,14 +10,15 @@
   libtimedate-perl,
   libdevel-cover-perl
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Homepage: https://github.com/linux-test-project/lcov.git
-Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
-Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
-Standards-Version: 4.6.2
+Homepage: https://github.com/linux-test-project/lcov
+Vcs-Browser: https://salsa.debian.org/mckinstry/lcov
+Vcs-Git: https://salsa.debian.org/mckinstry/lcov.git -b debian/latest
+Standards-Version: 4.7.0
 
 Package: lcov
 Architecture: all
 Depends:
+  python3:any | python3-minimal:any,
   ${misc:Depends},
   ${perl:Depends},
   ${python3:Depends},
@@ -29,7 +31,6 @@
 Recommends: libgd-gd2-perl
 Multi-Arch: foreign
 Section: devel
-Priority: optional
 Description: Summarise Code coverage information from GCOV
  LCOV is an extension of GCOV, a GNU tool which provides information about
  what parts of a program are actually executed (i.e. "covered") while running
