=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 export LC_ALL
 
 %:
-	dh $@ --no-parallel
+	dh $@ --no-parallel --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
