## lcov 2.3

=== Makefile ===
--- 
+++ 
@@ -66,7 +66,10 @@
 DIST_CONTENT := CONTRIBUTING COPYING README Makefile lcovrc \
 	bin example lib man rpm scripts tests
 
-EXES = lcov genhtml geninfo genpng gendesc perl2lcov py2lcov xml2lcov xml2lcovutil.py
+EXES = \
+	lcov genhtml geninfo genpng gendesc \
+	perl2lcov py2lcov xml2lcov xml2lcovutil.py \
+	llvm2lcov
 # there may be both public and non-public user scripts - so lets not show
 #   any of their names
 SCRIPTS = $(shell ls scripts | grep -v -E '([\#\~]|\.orig|\.bak|\.BAK)' )
@@ -119,7 +122,7 @@
 		$(INSTALL) -m 755 bin/$$b $(BIN_INST_DIR)/$$b ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir --fixbindir \
+		       --fixver --fixlibdir --fixbindir \
 		       --exec $(BIN_INST_DIR)/$$b ; \
 	done
 	$(INSTALL) -d -m 755 $(SCRIPT_INST_DIR)
@@ -128,7 +131,7 @@
 		$(INSTALL) -m 755 scripts/$$s $(SCRIPT_INST_DIR)/$$s ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir \
+		       --fixver --fixlibdir \
 		       --fixscriptdir --scriptdir $(SCRIPT_DIR) \
 		       --exec $(SCRIPT_INST_DIR)/$$s ; \
 	done
@@ -138,7 +141,7 @@
 		$(INSTALL) -m 644 lib/$$l $(LIB_INST_DIR)/$$l ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir --fixbindir \
+		       --fixver --fixlibdir --fixbindir \
 		       --exec $(LIB_INST_DIR)/$$l ; \
 	done
 	for section in 1 5 ; do \
@@ -188,7 +191,7 @@
 	$(call echocmd,"  UNINST  $(CFG_INST_DIR)/lcovrc")
 	$(RM) -f $(CFG_INST_DIR)/lcovrc
 	rmdir --ignore-fail-on-non-empty $(CFG_INST_DIR) || true
-	rmdir --ignore-fail-on-non-empty $(PREFIX)$(DESTDIR) || true
+	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(PREFIX) || true
 
 dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
       lcov-$(VERSION)-$(RELEASE).src.rpm
@@ -230,6 +233,7 @@
 		lcov-$(VERSION)/rpm/lcov.spec \
 	)
 	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
+		 --define "_target_os linux" \
 		 --undefine vendor --undefine packager \
 		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec --quiet
 	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
@@ -261,6 +265,7 @@
 	fi
 	@$(MAKE) -s -C tests check LCOV_HOME=`pwd`
 	@if [ "x$(COVERAGE)" != 'x' ] ; then       \
+	  $(MAKE) -s -C example LCOV_HOME=`pwd`;   \
 	  $(MAKE) -s -C tests report ;             \
 	fi
 
@@ -294,5 +299,3 @@
 	@if [ "$(origin VERSION)" != "command line" ] ; then echo "Please specify new version number, e.g. VERSION=1.16" >&2 ; exit 1 ; fi
 	@if [ -n "$$(git status --porcelain 2>&1)" ] ; then echo "The repository contains uncommitted changes" >&2 ; exit 1 ; fi
 	@if [ -n "$$(git tag -l v$(VERSION))" ] ; then echo "A tag for the specified version already exists (v$(VERSION))" >&2 ; exit 1 ; fi
-	@echo "Preparing release tag for version $(VERSION)"
-	git checkout master
