=== debian/changelog ===
lcov (2.3-1) unstable; urgency=medium

  * New upstream release. Closes: #1093145
  * Close old bugs: Closes: #1085234
  * Re-enable tests, but capture, dont fail. Closes: #1064030

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Jan 2025 07:50:08 +0000

lcov (2.1-2) unstable; urgency=medium

  * Relax dep to gcc| llvm. Thanks to Andrea Pappacoda. Closes: #1085234

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 17 Oct 2024 10:35:52 +0100
