=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
   ${misc:Depends},
   ${perl:Depends},
   ${python3:Depends},
-  gcc,
+  gcc | llvm,
   libcapture-tiny-perl,
   libdatetime-perl,
   libtimedate-perl,
